%define ALD_Ver		1.2.4


Name:         libnl

License:      LGPL
Summary:      Convenience library for netlink sockets
Group:        System Environment/Libraries
Version:      3.2.27
Release:      0

Source: %{name}-%{version}.tar.xz
Source1: CROSS.sh
Source2: %{name}-%{version}-patches.tgz

%define DestDir		/net
# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%define BUILD_LOCAL_CROSS 0
%else
# rpm --target=x86_64/armv6l/win32 -ba xxxxx.spec
%define _CROSS 1
%define BUILD_LOCAL_CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%define _libexecdir	%{_sbindir}

%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif
%define target_  %{target}-

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin

%define __os_install_post %{nil}

%define cross_sysconfdir %{csysdir}%{_sysconfdir}
%define cross_bindir	%{csysdir}%{_bindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}
%define target_  %{nil}

%endif # !_CROSS

%define docdir %{_defaultdocdir}/%{name}

# ------------------- description ------------------------------------
%description
Convenience library for netlink sockets
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel
These libraries are needed to compile C code.
#-------------------------------
%package cli
Summary:      Command Line Interface library for netlink sockets
Group:        Development/Libraries
%description cli
Command Line Interface library for netlink sockets
#-------------------------------
%package devel-cli
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel-cli
These libraries are needed to compile C code.
#-------------------------------
%package idiag
Summary:      librari libnl-idiag-3.so.200
Group:        Development/Libraries
%description idiag
librari libnl-idiag-3.so.200
#-------------------------------
%package devel-idiag
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel-idiag
These libraries are needed to compile C code.
#-------------------------------
%package route
Summary:      librari libnl-route-3.so.200,libnl-nf-3.so.200
Group:        Development/Libraries
%description route
librari libnl-route-3.so.200,libnl-nf-3.so.200
#-------------------------------
%package devel-route
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel-route
These libraries are needed to compile C code.
#-------------------------------
%package xfrm
Summary:      librari libnl-xfrm-3.so.200
Group:        Development/Libraries
%description xfrm
librari libnl-xfrm-3.so.200
#-------------------------------
%package devel-xfrm
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel-xfrm
These libraries are needed to compile C code.
#-------------------------------
%package %{TO_ARCH}
Summary:      %{name} Cross-%{TO_ARCH} Libraries
Group:        Development/Libraries
%description %{TO_ARCH}
%{name} Cross-%{TO_ARCH} Libraries

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

tar -xaf %SOURCE2
patch -p1<patches/nlmsg_reserve-overflow.patch

# ------------------- Build ------------------------------------------
%Build 
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

GCC_VER_STR=`%{target_}gcc -dumpversion`
LDFLAGS=" "

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i486 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-unwind-tables -fno-asynchronous-unwind-tables" ;; esac`
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-unwind-tables -fno-asynchronous-unwind-tables" ;; esac`
LDFLAGS=`case $GCC_VER_STR in 4.[56789].*) echo -static-libgcc ;; esac`
%endif
%if %{_arch} == "arm"
OPTFLAGS="-Os -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
OPT47=
%endif

#CFLAGS="$OPTFLAGS $OPT47 -std=gnu99 -D_GNU_SOURCE"
CFLAGS="$OPTFLAGS $OPT47 -std=gnu99"
CXXFLAGS="$OPTFLAGS"

%configure \
%if %{_CROSS}
	--host=%{target} \
%endif
	--enable-shared \
	--disable-static \
	--disable-libtool-lock \
	--disable-debug \
	&>FConfigure_log.txt


make V=1 &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>Finstall_log.txt
rm $RPM_BUILD_ROOT%{_libdir}/*.la
rm $RPM_BUILD_ROOT%{_libdir}/libnl/cli/cls/*.la
rm $RPM_BUILD_ROOT%{_libdir}/libnl/cli/qdisc/*.la

#cp COPYING $RPM_BUILD_ROOT%{docdir}/
ln -s /usr/share/doc/lgpl-2.1.txt $RPM_BUILD_ROOT%{docdir}/COPYING.LIB

%if %{_CROSS}
TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=%{BUILD_LOCAL_CROSS}
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR
%SOURCE1
%endif #_CROSS

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean 

DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
DEC=%{version}-%{release}.%{_build_cpu}.rpm
DDC=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
%if (%{_os} == "mingw")
  rm %{name}-$SE
%if %{BUILD_LOCAL_CROSS}
  mkdir -p $DDC
  mv %{name}-%{TO_ARCH}-$SE $DDC/%{name}-%{TO_ARCH}-$DEC
%endif #BUILD_LOCAL_CROSS
%else  #mingw
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-devel-$SE $DD/%{name}-devel-$DE
  mv %{name}-cli-$SE $DD/%{name}-cli-$DE
  mv %{name}-devel-cli-$SE $DD/%{name}-devel-cli-$DE
  mv %{name}-idiag-$SE $DD/%{name}-idiag-$DE
  mv %{name}-devel-idiag-$SE $DD/%{name}-devel-idiag-$DE
  mv %{name}-route-$SE $DD/%{name}-route-$DE
  mv %{name}-devel-route-$SE $DD/%{name}-devel-route-$DE
  mv %{name}-xfrm-$SE $DD/%{name}-xfrm-$DE
  mv %{name}-devel-xfrm-$SE $DD/%{name}-devel-xfrm-$DE
%if %{BUILD_LOCAL_CROSS}
  mkdir -p $DDC
  mv %{name}-%{TO_ARCH}-$SE $DDC/%{name}-%{TO_ARCH}-$DEC
%endif #BUILD_LOCAL_CROSS
%endif #!mingw
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
%if (%{_os} == "mingw")
  TMP_TO=$DD
%else
  TMP_TO=$DD/tar
%endif
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r etc usr $tmp/
%if (%{_os} == "mingw")
  zip -9 -r $tmp.zip $tmp >/dev/null
  mv $tmp.zip $TMP_TO
%else
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
%endif
  rm -r $tmp
%if %{BUILD_LOCAL_CROSS}
  TMP_TO=$DDC/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{TO_ARCH}-%{version}-%{release}.%{_build_cpu}
  mkdir -p $tmp
  cp -r cross $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%endif
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------
%Files
%defattr(-, root, root)
%{_sysconfdir}
%{_libdir}/libnl-3.so.*
%{_libdir}/libnl-genl-3.so.*
%{docdir}

%files devel
%defattr(-, root, root)
%{_includedir}/libnl3/netlink/*.h
%{_includedir}/libnl3/netlink/genl
%{_libdir}/libnl-3.so
%{_libdir}/libnl-genl-3.so
%{_libdir}/pkgconfig/libnl-3.0.pc
%{_libdir}/pkgconfig/libnl-genl-3.0.pc

%files cli
%defattr(-, root, root)
%{_bindir}
%{_libdir}/libnl-cli-3.so.*
%{_libdir}/libnl/cli
%{_mandir}

%files devel-cli
%defattr(-, root, root)
%{_includedir}/libnl3/netlink/cli
%{_includedir}/libnl3/netlink/fib_lookup
%{_libdir}/libnl-cli-3.so
%{_libdir}/pkgconfig/libnl-cli-3.0.pc

%files idiag
%defattr(-, root, root)
%{_libdir}/libnl-idiag-3.so.*

%files devel-idiag
%defattr(-, root, root)
%{_includedir}/libnl3/netlink/idiag
%{_libdir}/libnl-idiag-3.so
%{_libdir}/pkgconfig/libnl-idiag-3.0.pc

%files route
%defattr(-, root, root)
%{_libdir}/libnl-nf-3.so.*
%{_libdir}/libnl-route-3.so.*

%files devel-route
%defattr(-, root, root)
%{_includedir}/libnl3/netlink/netfilter
%{_includedir}/libnl3/netlink/route
%{_libdir}/libnl-nf-3.so
%{_libdir}/libnl-route-3.so
%{_libdir}/pkgconfig/libnl-nf-3.0.pc
%{_libdir}/pkgconfig/libnl-route-3.0.pc

%files xfrm
%defattr(-, root, root)
%{_libdir}/libnl-xfrm-3.so.*

%files devel-xfrm
%defattr(-, root, root)
%{_includedir}/libnl3/netlink/xfrm
%{_libdir}/libnl-xfrm-3.so
%{_libdir}/pkgconfig/libnl-xfrm-3.0.pc

# ------------------- Cross Files ------------------------------------
%if %{BUILD_LOCAL_CROSS}

%Files %{TO_ARCH}
%{cross_libdir}
%{cross_includedir}
%{cross_docdir}

%endif #!BUILD_LOCAL_CROSS
